searchData={"items":[{"type":"module","title":"ExTTY","doc":"","ref":"ExTTY.html"},{"type":"function","title":"ExTTY.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExTTY.html#child_spec/1"},{"type":"function","title":"ExTTY.send_text/2","doc":"","ref":"ExTTY.html#send_text/2"},{"type":"function","title":"ExTTY.start_link/1","doc":"","ref":"ExTTY.html#start_link/1"},{"type":"macro","title":"ExTTY.tty_pty/1","doc":"","ref":"ExTTY.html#tty_pty/1"},{"type":"macro","title":"ExTTY.tty_pty/2","doc":"","ref":"ExTTY.html#tty_pty/2"},{"type":"function","title":"ExTTY.window_change/3","doc":"","ref":"ExTTY.html#window_change/3"},{"type":"extras","title":"ExTTY","doc":"# ExTTY\n\n[![Hex version](https://img.shields.io/hexpm/v/extty.svg \"Hex version\")](https://hex.pm/packages/extty)\n[![CircleCI](https://circleci.com/gh/jjcarstens/extty.svg?style=svg)](https://circleci.com/gh/jjcarstens/extty)\n\nRun an Elixir or Erlang shell as a GenServer process\n\n# Installation\n\nInstall `extty` by adding it to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps() do\n  [\n    {:extty, \"~> 0.2\"}\n  ]\nend\n```\n\n# Usage\n\nThis is heavily adapted from [`ssh_cli.erl`](https://github.com/erlang/otp/blob/master/lib/ssh/src/ssh_cli.erl)\nand functions much like the SSH console implementation.\n\nThis will start a terminal shell process in a GenServer. You can then send ANSI text\nto it to behave like a normal TTY. When starting the shell, you must specify a handler\npid to receive the returned text data. The incoming message will be formatted as\n`{:tty_data, String.t()}`\n\n```elixir\n\niex()> {:ok, tty} = ExTTY.start_link(handler: self())\niex()> flush()\n{:tty_data, \"Interactive Elixir (1.10.3) - press Ctrl+C to exit (type h() ENTER for help)\\r\\n\"}\n{:tty_data, \"iex(1)> \"}\niex()> ExTTY.send_text(tty, \"1+1\\n\")\n:ok\niex()> flush()\n{:tty_data, \"1+1\\r\\n\"}\n{:tty_data, \"\\e[33m2\\e[0m\\r\\n\"}\n{:tty_data, \"iex(2)> \"}\n```","ref":"readme.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"* Adds support for Elixir 1.17\n  * This required using a different entry point into IEx and\n    adjusts the shape of `:shell_opts` to be a flat keyword list\n  * Elixir also renamed `:dot_iex_path` -> `:dot_iex`. The changes\n    here account for that for now, but if you previously included\n    this in options you'll need to change from\n    `shell_opts: [[dot_iex_path: path]]` to `shell_opts: [dot_iex: path]`\n* Minimum supported Elixir version is now 1.13","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Support Elixir 1.15 / OTP 26 with backwards compatibility","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"* Sync tty_cli.erl with ssh_cli.erl in Erlang\n  * `:onlcr` was set so that the CRLF behavior remained the same","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* Fixes\n  * `ExTTY` no longer defaults a `:name` option for GenServer start_link.\n  If you relied on the default `ExTTY` name, you will need to pass that or\n  a different name as the `:name` option explicitly and use it\n  (or the returned pid of `ExTTY.start_link/1`) when calling the\n  functions of `ExTTY`:\n\n  ```elixir\n  # Named GenServer\n  {:ok, _pid} = ExTTY.start_link(name: TTY1)\n  ExTTY.send_text(TTY1, \"1+1\\n\")\n\n  # Unnamed GenServer\n  {:ok, tty} = ExTTY.start_link()\n  ExTTY.send_text(tty, \"1+1\\n\")\n  ```","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown"}